//31/07/2019//

//variables//
var r k_a w_a j_a i pi b_a e ht_a he_a h_p y c_a pin x_a lambda_ac lambda_ak c_b w_b j_b lambda_bc j w cl pl c ce pe xl x xe k b be ht X_ls kg cmp X_L cap_s h pe_ast x_e cap_z he c_le gg bge d r_e bgt tau ba_pr ba_t h_pe p_oil y_oil ba_es;


varexo fac bae ex_p z i_e pi_e shock_c shock_i pi_est c_e i_est shock_re gf gi h_pe_est tau_est e_est p_oil_est y_est c_est w_est pin_est k_est r_est ba_eso;

 
parameters tau_k, tau_w, ex_ph, tau_c, tau_p, gamma_f,  sigma, beta, delta, kappa, gamma_r, mi, alpha_c, rho, alpha_i, eta, alpha, alpha_g, theta, omega_r, theta_e, ji, omega, sigma_i, i_lr, ni, prp_a, delta_g, ex_pg, tau_h_pe;
 
 
tau_k=0.0514;
tau_w= 0.145;
ex_ph=0.1151;
tau_c=0.0511;
tau_p=0.145;
gamma_f=1.4550;
sigma=2.00;
beta= 0.96;
delta=0.350;
kappa=0.1304;
gamma_r=0.45; 
mi=0.9464;
alpha_c=1;
rho=1.50;
alpha_i=1.5875;
eta=0.500;
alpha=0.3333;
alpha_g=0.587;
theta=0.1249;
omega_r=0.75;
theta_e=2.11;
ji=0.400;
omega=0.89;
sigma_i=0.08;
i_lr=0.0169;
ni=0.0036;
prp_a=0.02875;
delta_g=0.0351;
ex_pg=0.8849;
tau_h_pe=0;
 
 
 
 
 
model;

//Restriccin Hogares Ricardianos//
((1-tau_k)*r*k_a(-1))+((1-tau_w)*w_a*j_a)+((1+i(-1))/(1+pi))*((1/fac)*b_a)+(e*bae)+ht_a+he_a+(ex_p*ex_ph*h_p*y)+z=((1-tau_c)*c_a+pin*x_a)+b_a+(e*((1+i_e(-1))/(1+pi_e))*(1/fac)*bae(-1))+(tau_p*pin*k_a(-1));
lambda_ac=shock_c*(((shock_c*c_a)-((j_a^gamma_f)/(1+gamma_f)))^-sigma)/(1-tau_c);
j_a= shock_c*((1-tau_w)/( 1-tau_c))*w_a;

//Condiciones de primer orden//
lambda_ac=(beta*(1/fac)*lambda_ac*(1-tau_k)*r)+tau_p*pin+ (lambda_ak*(1-delta));
lambda_ac*pin=lambda_ak*shock_i*((1-(kappa/2)*((x_a/x_a(-1))-1)^2)-kappa*(x_a/x_a(-1))*((x_a/x_a(-1))-1))+beta*(lambda_ak(+1)* shock_i(+1)*fac(+1)^(-sigma)*kappa*((x_a(+1)/x_a)-1)*((x_a(+1)/x_a)-1)^2);
lambda_ac=beta*(lambda_ac(+1)*((1+i)/(1+pi(+1)))*(1/fac(+1)^sigma));
lambda_ac=beta*(lambda_ac(+1)*(e(+1)/e)*((1+i_e)/(1+pi_e(+1)))*(1/fac(+1)^sigma));

//Acumulacin de Capital//
k_a=shock_i*i*(1-(kappa/2)*((x_a/x_a(-1))-1)^2+(1-delta)*(k_a(-1)/fac));

//Restriccin hogares no ricardianos//
(1-tau_c)*c_b=(1-tau_w)*w_b*j_b;
lambda_bc=((((shock_c*c_b-(j_b^gamma_f/(1+gamma_f))))^sigma)* shock_c)/(1-tau_c);
j_b= shock_c*((1-tau_w)/( 1-tau_c))*w_b;  

//Oferta de trabajo total//
j_a*gamma_r+(1-gamma_r)*j_b=j;


//Salario real de la economa//
w=w_a;
w=w_b;

//Demanda consumo interno//
cl=(1-alpha_c)*pl^(-rho)*c;

//Demanda de consumo externo//
ce=alpha_c*pe^(-rho)*c;

//Indice de precios de la economa//
1=((1-alpha_c)*(pl)^(1-rho)+alpha_c*(pe)^(1-rho))^(1/(1-rho));



//Demanda por inversin interna//
xl=(1-alpha_i)*(pl/pin)^(-eta)*x;


//DEmanda por inversin externa//
xe=alpha_i*(pe/pin)^(-eta)*x;

//Precio relativo bienes de inversin//
pin=(((1-alpha_i)*(pl^(1-eta))+alpha_i*pe^(1-eta))^(1/(1-eta)));

//Definicin de precios//

((1+pi)/(1+pi(-1)))=pl/pl(-1);
((1+pi_e)/(1+pi(-1)))=pe/pe(-1);
c_a*gamma_r+(1-gamma_r)*c_b=c;
k=gamma_r*k_a;
x=gamma_r*x_a;
b=gamma_r*b_a;
be=gamma_r*bae;
ht=gamma_r*ht_a;



//Funcin de produccin de la firma de bienes intermedios//
X_ls=mi*(k(-1)/fac)^alpha*j^(1-alpha)*(kg(-1)/fac)^alpha_g;

//Demanda de factores//
w=cmp*(1-alpha)*(X_L/j);
r=cmp*alpha*fac*(X_L/k(-1));


//Condicin de primer orden//
(1-theta)*pl+(theta*cmp)-pl*kappa*(((1+pi)/(1+pi(-1))^omega_r*(1+pi_est)^(1-omega_r))-1)*((1+pi)/(1+pi(-1))^omega_r*(1+pi_est)^(1-omega_r))+beta*(lambda_ac(+1)/lambda_ac)*(fac(+1)^(1-sigma))*(((1-tau_p(+1))*X_L(+1))/((1-tau_p)*X_L))*(pl(+1)*kappa*(((1+pi)/(1+pi(-1))^omega_r*(1+pi_est)^(1-omega_r))-1)*((1+pi)/(1+pi(-1))^omega_r*(1+pi_est)^(1-omega_r)));


//Ajuste de precios //
cap_s=(kappa/2)*((1+pi)/((1+pi(-1))^omega_r*(1+pi_est)^(1-omega_r))-1)^2;

//Beneficios de la economa//
h=(pl*(1-cap_s)-cmp)*X_ls;

//Beneficios despues de impuestos//
ht=(1-tau_p)*h;

//condicin de rimer orden firma importadora//
(1-theta_e)*pe+(theta_e*e*pe_ast)-pe*kappa*(((1+pi_e)/(1+pi_e(-1))^omega_r*(1+pi_est)^(1-omega_r))-1)*((1+pi_e)/(1+pi_e(-1))^omega_r*(1+pi_est)^(1-omega_r))+(beta*(lambda_ac(+1)/lambda_ac)*(fac(+1)^(1-sigma))*(pe(+1)*kappa*(((1+pi_e)/(1+pi_e(-1))^omega_r*(1+pi_est)^(1-omega_r))-1)*((1+pi_e)/(1+pi_e(-1))^omega_r*(1+pi_est)^(1-omega_r)))*(x_e(+1)/x_e));

//Ajuste de precios//
cap_z=( kappa/2)*((1+pi_e)/((1+pi_e(-1))^omega_r*(1+pi_est)^(1-omega_r))-1)^2;

//Beneficios//
he=(pe*(1-cap_z)-e*pe)*x_e;

//Demanda de exportaciones//
c_le=((pl/e)^ji)*c_e;

//GDP//
(1- cap_s)*X_L=cl+xl+gg+c_le;

//El bien importado se reparte entre consumo e inversin importada//
(1- cap_z)*x_e=ce+xe;

//Tasa de inters de extranjera//

(1+i)=((1+i(-1))^omega*((1+i_est)*((1+pi(+1))/(1+pi_est))^sigma_i))^(1-omega)*exp(e);
(1+i_e)=(1+i_lr)*(shock_re)*(ni*((be+bge)/y)-prp_a);
(1+r)=((1+i)/(1+pi(+1)));
(1+r_e)=((1+i_e)/(1+pi_e(+1)));

//Devaluacin//
d=(e(+1)/e);

//Gasto del gobierno//
gg=gf+gi;

//Acumulacin de capital del gobierno//
kg=gi+pi*(1-delta_g)*(kg(-1)/fac);

//Deuda total del gobierno //
bgt=b+(e*bge);

//Restriccin presupuestaria del gobierno//
pl*gg+((1+i(-1))/(1+pi))*(1/fac)*b(-1)+e*((1+i_e(-1))/(1+pi_e))*bge(-1)=tau_c*c+tau_w*w+tau_p*(1/fac)*pin*k(-1)-pin*x+(tau_k)*r*k(-1)+ex_ph*ex_pg*h_p*y+b+e*bge;ba_pr=ex_ph*ex_pg*h_p*y-(pl*gg);
tau= tau_c*c+tau_w*w+tau_p*(1/fac)*pin*k(-1)- pin*x+(tau_k)*r*k(-1)+tau_p*ht;



//Balance primario//
ba_pr=tau+ex_ph*ex_pg*h_p*y-(pl*gg);

//Balance total//
ba_t=ba_pr-((i(-1))/(1+pi))*(b(-1)/fac)-e*((i_e(-1))/(1+pi_e))*(bge(-1)/fac);

//Balance estructural//
ba_es=ba_pr-h_pe_est-tau_est;

h_pe_est=(e*p_oil-(e_est*p_oil_est))*y_oil;
tau_est=tau_c*(c-c_est)+tau_w*(w-w_est)+tau_p*(1/fac)*(pin*k(-1))-(pin_est*k_est(-1))+tau_h_pe*(h_pe-h_pe_est)+(tau_k/fac)*(r*k(-1))-(r_est*k_est(-1));

//Regla fiscal//
ba_eso=ba_es*y_est;

 
end;
 
initval;
r=-0.0322;
k_a=0.6458;
w_a=0.000000439;
j_a=47;
i=0.062989;
pi=0.0504;
b_a=0;
e=114.23;
ht_a=0;
he_a=0;
h_p=0.00064;
y=0.03;
c_a=0.7773;
pin=1;
x_a=0.5497;
lambda_ac=0;
lambda_ak=0;
c_b=0.5377;
w_b=0.000000439;
j_b=47;
lambda_bc=0;
j=47;
w=0.000000439;
cl=0.6800;
pl=1;
c=0.6800;
ce=0.1619;
pe=1;
xl=0.2027;
x=0.2027;
xe=0.0364;
k=0.2035;
b=0.3562;
be=0.1780;
ht=0;
X_ls=0.8460;
kg=0.3775;
cmp=0;
X_L=168.11;
cap_s=0;
h=0;
pe_ast=1;
x_e=1;
cap_z=0;
he=0;
c_le=0.1154;
gg=0.1575;
bge=0.218;
d=1.0080;
r_e=1;
bgt=0.4720;
tau=0.1289;
ba_pr=-0.0052;
ba_t=-0.0357;
h_pe=0;
p_oil=121833;
y_oil=0.04041;
ba_es=-0.00230;
end;
 
steady;
 
check;


